/* 15_15.cpp
	This program changes the value of a variable,
	by calling three different functions. First of the 
	function is called by value, the second is by pointer
	and the third by reference.
*/
#include <iostream>

using std::cout;
using std::cin;
using std::endl;

int add1CallByValue ( int );
void add1CallByPointer ( int * );
void add1CallByReference ( int & );

int main()
{
	int count = 0;

	cout << "Initial value of count : " << count << endl;

	count = add1CallByValue( count ); /* Call function by value */
	cout << "Value of count after call by value : " << count << endl;

	add1CallByPointer( &count ); /* Call function by pointer */
	cout << "Value of count after call by pointer: " << count << endl;

	add1CallByReference( count ); /* Call function by reference */
	cout << "Value of count after call by reference : " << count << endl;
	return 0;
}

int add1CallByValue ( int value )
{
	return ++value;
}

void add1CallByPointer( int *value )
{
	(*value) ++; 
}

void add1CallByReference( int &value )
{
	value++;
}