/*	15_20.cpp
	This program finds the maximum value of three variables
	using a template function and a macro. A ternary structure
	is used in macro definition.
*/
#include <iostream>

using std::cout;
using std::cin;
using std::endl;

#define maxMacro( value1, value2, value3 ) \
	( (value1 > value2) ? ((value1 > value3) ? value1 : value3) : \
	((value2 > value3) ? value2 : value3) ) \

template < class T >
T maxByTemplate(T value1, T value2, T value3)
{
   T maxValue = value1;

   if ( value2 > maxValue )
      maxValue = value2;

   if ( value3 > maxValue )
      maxValue = value3;

   return maxValue;
}



int main()
{
	int integer1 = 12, 
		integer2 = 24,
		integer3 = -12;

	float float1 = 123.2,
		  float2 = 34.89,
		  float3 = -987.987;

	char char1 = 'e',
		 char2 = 'E',
		 char3 = '1';

	/* Find Max values by using function template */
	cout << "Find max. values using function template" << endl << endl;

	cout << "integers : " << integer1 << " "
		 << integer2 << " "
		 << integer3 << " Max :" << maxByTemplate( integer1, integer2, integer3 )
		 << endl;

	cout << "floats : " << float1 << " "
		 << float2 << " "
		 << float3 << " Max :" << maxByTemplate( float1, float2, float3 )
		 << endl;

	cout << "characters: " << char1 << " "
		 << char2 << " "
		 << char3 << " Max :" << maxByTemplate( char1, char2, char3 )
		 << endl;

	/* Find Max values with macro */
	cout << endl << endl << "Find max. values using macro" << endl << endl;	

	cout << "integers : " << integer1 << " "
		 << integer2 << " "
		 << integer3 << " Max :" << maxMacro( integer1, integer2, integer3 )
		 << endl;

	cout << "floats : " << float1 << " "
		 << float2 << " "
		 << float3 << " Max :" << maxMacro( float1, float2, float3 )
		 << endl;

	cout << "characters: " << char1 << " "
		 << char2 << " "
		 << char3 << " Max :" << maxMacro( char1, char2, char3 )
		 << endl;

	return 0;
}