/* Simpletron simulator program                                */
/* This program simulates the working of simpletron            */
/* The ones who know using simpletron can use this program     */
/* Written by Krsad YILDIRIM                                  */
#include <stdio.h>
#include <conio.h>
#include <math.h>

#define Memory_Size 100
#define Name_Size 13

/* Input/Output operations */
#define READ 10
#define WRITE 11
/* Load/Store operations */
#define LOAD 20
#define STORE 21
/* Arithmetic operations */
#define ADD 30
#define SUBTRACT 31
#define DIVIDE 32
#define MULTIPLY 33
/* Transfer of control operations*/
#define BRANCH 40
#define BRANCHNEG 41
#define BRANCHZERO 42
#define HALT 43
/* Sentinel*/
#define EXIT -99

void introduction();
void Load_Program(int [Memory_Size + 1], char [Name_Size], int *);
void Read_From_Keyboard(int [Memory_Size + 1], char [Name_Size], int *);
void Save_To_File(int Program[Memory_Size + 1], char [Name_Size]);
void Read_From_File(int [Memory_Size + 1], char [Name_Size], int *);
int  Error_Check(int [Memory_Size+1], int *);
void Execute(int [Memory_Size + 1], char[Name_Size]);
void Display(int [Memory_Size+1], char [Name_Size], int, int, int);

int main()
{  int Memory[Memory_Size + 1] = {0},Size = 0;
	char Program_Name[Name_Size];

	introduction();
	Load_Program(Memory, Program_Name, &Size);

	return 0;
}

void introduction()
{
	printf("\n\n\n\n\n\n\n");
	printf("          	***   Welcome to Simpletron!                    ***\n");
	printf("          	***   Simpletron is a fixed point processor     ***\n");
	printf("          	***   Please enter your program one instruction ***\n");
	printf("          	***   (or data word) at a time. I will type the ***\n");
	printf("          	***   location number and a question mark (?).  ***\n");
	printf("          	***   You then type the word for that location. ***\n");
	printf("          	***   Type the sentinel -99 to stop entering    ***\n");
	printf("          	***   your program.                             ***\n\n");
	printf("          	***   Press any key to continue                 ***\n");
	getch();
}

void Load_Program(int Memory[Memory_Size + 1], char Program_Name[Name_Size], int *Size)
{
	int choice;

	clrscr();
	printf("\n\t*** PLEASE MAKE YOUR SELECTION ***");
	printf("  \n1-) Load program by keyboard.");
	printf("  \n2-) Load program from a file.\n>>");
	scanf("%d",&choice);
	if (choice == 1){
		Read_From_Keyboard(Memory, Program_Name, Size);
		Execute(Memory,Program_Name);
	}
	else if (choice == 2){
		Read_From_File(Memory, Program_Name, Size);
	}
	else
		printf("\n\t !!! OOPSS I THINK YOU MADE A MISTAKE !!!\n\t !!! PLEASE RERUN SIMPLETRON          !!!");

}

void Read_From_Keyboard(int New_Program[Memory_Size + 1], char Program_Name[Name_Size], int *Size)
{
	int Instruction_Register = 0, Instruction_Counter = 0;
	char Prog_Name[Name_Size], flag = ' ';

	clrscr();
	printf("\nPROGRAM:");
	printf("\n\t00 ? ");
	scanf("%d",&Instruction_Register);
	New_Program[Instruction_Counter++] = Instruction_Register;
	while ((Instruction_Register != EXIT) && (Instruction_Counter <= Memory_Size-2)){
		printf("\t%.2d ? ",Instruction_Counter);
		scanf("%d",&Instruction_Register);
		New_Program[Instruction_Counter++] = Instruction_Register;
		if (Instruction_Counter == Memory_Size){
			printf("\n Memory is full \n Not enough space for new instructions\n");
			printf("Press any key to continue");
			getch();
			Instruction_Register = EXIT;
			New_Program[Memory_Size] = Instruction_Register;
		}
	}
	printf("\n\n Enter a name for your program '*.dat'(Do not exceed 8 characters) =>");
	scanf("%s",Prog_Name);
	for (int i = 0; i <= 12; i++)
		Program_Name[i] = Prog_Name[i];
	*Size = Instruction_Counter - 1;
	printf("\n\n\t*** Program loading completed                            ***");
	printf("\n\t*** Do you want to save this program in a dat file (y/n) ***");
	while ((flag != 'y') && (flag != 'n') && (flag != 'y') && (flag != 'n')){
		flag = getch();
		if (flag == 'y')
		  Save_To_File(New_Program, Program_Name);}
	printf("\n\t*** Press any key to start execution of '%12s' ***",Program_Name);
	getch();
}

void Read_From_File(int New_Program[Memory_Size + 1], char Program_Name[Name_Size], int *Size)
{
	int Instruction_Register = 0, Instruction_Counter = 0;
	char File_Name[Name_Size];

	FILE *sfPtr;

	clrscr();
	printf("Enter the name of the file you want to run('*.dat') \n");
	printf("Loaded file will be echoed on the screen =>");
	scanf("%s", File_Name);
	if ((sfPtr = fopen(File_Name,"r")) == NULL)
		printf("\nFile could not be opened");
	else {
	printf("\nPROGRAM:");
	printf("\n\t00 ? ");
	fscanf(sfPtr, "%d", &Instruction_Register);
	printf("%.2d", Instruction_Register);
	New_Program[Instruction_Counter++] = Instruction_Register;
	while ((!feof(sfPtr)) && (Instruction_Counter <= Memory_Size-2)){
		printf("\n\t%.2d ? ",Instruction_Counter);
		fscanf(sfPtr, "%d", &Instruction_Register);
		printf("%.2d", Instruction_Register);
		New_Program[Instruction_Counter++] = Instruction_Register;
		if (Instruction_Counter == Memory_Size){
			printf("\n Not enough memory space\n Loading could not be completed\n");
			printf(" Execution will continue.\n");
			printf(" Press any key to continue");
			getch();
			Instruction_Register = EXIT;
			New_Program[Memory_Size] = Instruction_Register;
		}
	}
	*Size = Instruction_Counter - 1;
	fclose(sfPtr);
	for (int i = 0; i <= 12; i++)
		Program_Name[i] = File_Name[i];
	printf("\n\n\t*** Program loading completed                          ***");
	printf("\n\t*** Press any key to start execution of '%12s' ***",File_Name);
	getch();
	Execute(New_Program, Program_Name);

	}
}
void Save_To_File(int Program[Memory_Size + 1], char File_Name[Name_Size])
{
	int counter = 0;

	FILE *dfPtr;

	if ((dfPtr = fopen(File_Name,"w")) == NULL)
		printf("\n File could not be opened");
	else {
		while (Program[counter] != EXIT)
		fprintf(dfPtr,"+%.4d\n",Program[counter++]);
	}
   fclose(dfPtr);

}
void Execute(int Program[Memory_Size + 1], char Prog_Name[Name_Size])
{
	int accumulator = 0, Operation_Code = 0, operand = 0;
	int Instruction_Counter = 0,Instruction_Register = 0;
	int Syntax_Error = 0, Runtime_Error = 0;
	int Program_End = 0, Error_Position = 0, temp = 0;

	clrscr();
	printf("\t\t ***** EXECUTING '%12s' *****",Prog_Name);
	Syntax_Error = Error_Check(Program, &Error_Position);
	while ((Syntax_Error != 1) && (Runtime_Error != 1) && (Program_End != 1)){
		Instruction_Register = Program[Instruction_Counter++];
		Operation_Code = Instruction_Register / 100;
		operand = Instruction_Register % 100;
		switch (Operation_Code){

			case READ:
				printf("\n\n\t<< ");
				scanf("%d", &temp);
				Program[operand] = temp;
				while (Program[operand] > 9999)
				Program[operand] = floor(temp / 10);
				break;
			case WRITE:
				printf("\n\t>> %.2d", Program[operand]);
				break;
			case LOAD:
				accumulator = Program[operand];
				break;
			case STORE:
				Program[operand] = accumulator;
				break;
			case ADD:
				accumulator += Program[operand];
				break;
			case SUBTRACT:
				accumulator -= Program[operand];
				break;
			case DIVIDE:
				if (Program[operand] == 0){
					printf("\n\n\t*** Attempt to divide by zero ***");
					printf("\n\t*** Simpletron execution abnormally terminated ***");
					Runtime_Error = 1;
					Error_Position = Instruction_Counter - 1;
				}
				else
					accumulator = accumulator / Program[operand];
				break;
			case MULTIPLY:
				accumulator *= Program[operand];
				break;
			case BRANCH:
				Instruction_Counter = operand;
				break;
			case BRANCHNEG:
				if (accumulator < 0)
					Instruction_Counter = operand;
				break;
			case BRANCHZERO:
				if (accumulator == 0)
					Instruction_Counter = operand;
				break;
			case HALT:
				Program_End = 1;
								break;
		}
	}
	if (Syntax_Error == 1 ){
		printf("\n\n\n\t!!! Syntax error detected at line %.2d !!!\n",Error_Position);
		printf("\t!!! Execution will not start         !!!\n");
	}
	else if(Program_End == 1){
		printf("\n\n\n\n\t*** End of program '%12s'                ***\n",Prog_Name);
		printf("\t*** Simpletron execution terminated              ***\n");
		printf("\t*** Press 'd' to display memory and registers or ***\n");
		printf("\t*** Any other key to end up the session          ***");
		if ((getch() == 'd') || (getch() == 'D'))
			Display(Program, Prog_Name, accumulator, Instruction_Counter, Instruction_Register);
	}

}
int Error_Check(int Prog[Memory_Size+1], int *position)
{
	 int error = 0, end = 0, opcode = 0, counter = 0;

	 while ((error != 1) && (end != 1)){
		 opcode = Prog[counter++]/100;
		 switch (opcode){

			case READ:
				break;
			case WRITE:
				break;
			case LOAD:
				break;
			case STORE:
				break;
			case ADD:
				break;
			case SUBTRACT:
				break;
			case DIVIDE:
				break;
			case MULTIPLY:
				break;
			case BRANCH:
				break;
			case BRANCHNEG:
				break;
			case BRANCHZERO:
				break;
			case HALT:
				break;
			case 0:
				end = 1;
				Prog[counter-1] = 0;
				break;
			default:
				error = 1;
				counter--;
				*position = counter;
				break;
		 }
	 }
	 return error;
}
void Display(int Memory[Memory_Size+1], char Prog_Name[Name_Size], int accumulator,
				 int Instruction_Counter, int Instruction_Register)
{
	int counter = 0;

	clrscr();
	printf("CONTENT OF SIMPLETRON AFTER EXECUTING '%12s'\n\n",Prog_Name);
	printf("\tREGISTERS:\n");
	printf((accumulator >= 0) ? "\tAccumulator           => +%.4d\n" : "\tAccumulator           => %.4d\n",accumulator);
	printf("\tInstruction Counter   =>    %.2d\n",Instruction_Counter);
	printf("\tInstruction Register  => +%.4d\n\n",Instruction_Register);
	printf("\tMEMORY:\n");
	printf("\t       0     1     2     3     4     5     6     7     8     9\n");
	for(int i = 0; i <= 9; i++){
		printf("\t%2d",10 * i);
		for(int j = 0; j <= 9; j++){
			printf((Memory[counter-1] >= 0) ? " +%.4d" : " %.4d",Memory[counter++]);
		}
		printf("\n");
	}
	printf("\n*** PRESS ANY KEY TO END UP THE SESSION ***");
	getch();
}


