// TIME3.H
// Declaration of the Time class

//prevent multiple inclusions of the header file
#ifndef TIME3_H
#define TIME3_H

class Time{
public:
	Time(int hr = 0, int min = 0, int sec = 0)   // constructor
	{
		hour = (hr >= 0 && hr < 24) ? hr : 0;
		minute = (min >= 0 && min < 59) ? min : 0;
		second = (sec >= 0 && sec < 59) ? sec : 0;
	}

	// set functiond
	void setTime(int h, int m, int s) 	// set hour, minute, second
	{
		hour = (h >= 0 && h < 24) ? h : 0;
		minute = (m >= 0 && m < 60) ? m : 0;
		second = (s >= 0 && s < 60) ? s : 0;
	}
	void setHour(int h)     // set Hour
		{ hour = (h >= 0 && h < 24) ? h : 0; }
	void setMinute(int m)   // set Minute
		{ minute = (m >= 0 && m < 60) ? m : 0; }
	void setSecond(int s)   // set Second
		{ second = (s >= 0 && s < 60) ? s : 0; }

	// get functions
	int getHour() { return hour; }          // return Hour
	int getMinute(){ return minute; }       // return Minute
	int getSecond(){ return second; }       // return Second

	void printMilitary()                    // output military time
	{
		cout << (hour < 10 ? "0" : "") << hour << ":"
			  << (minute < 10 ? "0" : "") << minute << ":"
			  << (second < 10 ? "0" : "") << second;
	}
	void printStandard()                       // output standard time
	{
		cout << ((hour == 0 || hour == 12) ? 12 : hour % 12) << ":"
			  << (minute < 10 ? "0" : "") << minute << ":"
			  << (second < 10 ? "0" : "") << second << ":"
			  << (hour < 12 ? " AM" : " PM");
	}
	void incrementSeconds(const int count)
	{
		for (int i = 1; i <= count; i++){
			setSecond((getSecond() + 1) % 60);
			if (getSecond() == 0)
				setMinute((getMinute() + 1) % 60);
			if ((getMinute() == 0) && getSecond() == 0)
				setHour((getHour() + 1) % 24);
         cout << "\n";
			printStandard();
		}
	}
private:
	int hour;              // 0-23
	int minute;            // 0-59
	int second;            // 0-59
};

#endif

